/*+------------------------------------------------------------------+
 | Alberto PREV Day.mq4                                             |
 |                                                                  |
 +------------------------------------------------------------------+*/

#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color1 Lime 
#property indicator_color2 Lime 

#property indicator_color3 Aqua 
#property indicator_color4 Red 
#property indicator_color5 Red   

#property indicator_color6 Aqua   
#property indicator_color7 Lime   
#property indicator_color8 Lime  

extern double Level_1 = 20;
extern double Level_2 = 40;
extern double Level_3 = 60;

//---- input parameters

//---- buffers

double PrevDayHiBuffer[];
double PrevDayLoBuffer[];

double Take1Buffer[];
double Take2Buffer[];
double StopLongBuffer[];

double Take4Buffer[];
double Take5Buffer[];
double StopShortBuffer[];

int fontsize=10;
double PrevDayHi, PrevDayLo, Take1, Take2, StopLong, StopShort, Take4, Take5 ;
double LastHigh,LastLow,x;


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
  
   ObjectDelete("PrevDayHi");
   ObjectDelete("PrevDayLo"); 
   ObjectDelete("Take1");  
   ObjectDelete("Take2"); 
   ObjectDelete("StopLong");        
   ObjectDelete("Take4");    
   ObjectDelete("Take5");      
   ObjectDelete("StopShort");      

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexStyle(7,DRAW_LINE);
   
   SetIndexBuffer(0, Take2Buffer);
   SetIndexBuffer(1, Take1Buffer);
   SetIndexBuffer(2, PrevDayHiBuffer);
   SetIndexBuffer(3, StopLongBuffer);
   SetIndexBuffer(4, StopShortBuffer);   
   SetIndexBuffer(5, PrevDayLoBuffer);
   SetIndexBuffer(6, Take4Buffer);
   SetIndexBuffer(7, Take5Buffer);
  
//---- name for DataWindow and indicator subwindow label

   short_name="Prev Hi-Lo levels";
   IndicatorShortName(short_name);
   SetIndexLabel(0, "Take2");  
   SetIndexLabel(1, "Take1");
   SetIndexLabel(2, "PrevDayHigh");
   SetIndexLabel(3, "StopLong");
   SetIndexLabel(4, "StopShort");
   SetIndexLabel(5, "PrevDayLow");
   SetIndexLabel(6, "Take4");
   SetIndexLabel(7, "Take5");
  
   

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int    counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)
{
   x=Period();
   if (x>240) return(-1);
   
//   ObjectCreate("PrevDayHi", OBJ_TEXT, 0, 0, 0);
//   ObjectCreate("PrevDayLo", OBJ_TEXT, 0, 0, 0);   
//   ObjectCreate("Take1", OBJ_TEXT, 0, 0, 0);
//   ObjectCreate("Take2", OBJ_TEXT, 0, 0, 0);
//   ObjectCreate("StopLong", OBJ_TEXT, 0, 0, 0);
//   ObjectCreate("Take4", OBJ_TEXT, 0, 0, 0);
//   ObjectCreate("Take5", OBJ_TEXT, 0, 0, 0);
//   ObjectCreate("StopShort", OBJ_TEXT, 0, 0, 0);
   

   //---- last counted bar will be recounted
   //     if(counted_bars>0) counted_bars--;
} 
  limit=(Bars-counted_bars)-1;



for (i=limit; i>=0;i--)
{ 

if (High[i+1]>LastHigh) LastHigh=High[i+1];
if (Low[i+1]<LastLow) LastLow=Low[i+1];
if (TimeDay(Time[i])!=TimeDay(Time[i+1]))
   { 
   PrevDayHi=LastHigh;
   PrevDayLo=LastLow;
   Take1     = PrevDayHi + (iATR(NULL,PERIOD_D1,4,1)*Level_1/100) ;
   Take2     = PrevDayHi + (iATR(NULL,PERIOD_D1,4,1)*Level_2/100) ;
   StopLong  = PrevDayHi - (iATR(NULL,PERIOD_D1,4,1)*Level_1/100) ;
   Take4     = PrevDayLo - (iATR(NULL,PERIOD_D1,4,1)*Level_1/100) ;
   Take5     = PrevDayLo - (iATR(NULL,PERIOD_D1,4,1)*Level_2/100) ;
   StopShort = PrevDayLo + (iATR(NULL,PERIOD_D1,4,1)*Level_1/100) ; 
   LastLow   = Open[i];
   LastHigh  = Open[i];
  
   ObjectMove("PrevDayHi", 0, Time[i], PrevDayHi);
   ObjectMove("PrevDayLo", 0, Time[i], PrevDayLo);
   ObjectMove("Take1", 0, Time[i], Take1);
   ObjectMove("Take2", 0, Time[i], Take2);
   ObjectMove("StopLong", 0, Time[i], StopLong);
   ObjectMove("Take4", 0, Time[i], Take4);
   ObjectMove("take5", 0, Time[i], Take5);
   ObjectMove("StopShort", 0, Time[i], StopShort);
   
   }
   
   PrevDayHiBuffer[i]=PrevDayHi;
   PrevDayLoBuffer[i]=PrevDayLo;
   Take1Buffer[i]=Take1;
   Take2Buffer[i]=Take2;
   StopLongBuffer[i]=StopLong;
   Take4Buffer[i]=Take4;
   Take5Buffer[i]=Take5;
   StopShortBuffer[i]=StopShort;
    
}

//----
   return(0);
  }
//+------------------------------------------------------------------+